#include <LiquidCrystal.h>
#include <ModbusRtu.h>
LiquidCrystal _lcd1(12, 11, 5, 4, 3, 2);
int _dispTempLength1=0;
boolean _isNeedClearDisp1;

Modbus _modbusMaster(0, 0, 13);
uint16_t _regModSlav_1[9];
modbus_t _modTelegrSend1;
modbus_t _modTelegrRead1;
unsigned long _modbusTimeVar1 = millis();
bool _isNeesdedSinhronizeSlave1 =0;
uint8_t _modState;
int  _modTlgIndex = -1;
bool  _isModbusRead = 0;
int _gtv1;
int _disp1oldLength = 0;
int _disp2oldLength = 0;
bool _gen1I = 0;
bool _gen1O = 0;
unsigned long _gen1P = 0UL;
bool _count1I = 0;
int _count1P = 0;
int _bitW1;
int _bitW2;
bool _trgt1 = 0;
bool _trgt1I = 0;
bool _trgt2 = 0;
bool _trgt2I = 0;
bool _bounseInput7S = 0;
bool _bounseInput7O = 0;
unsigned long _bounseInput7P = 0UL;
bool _bounseInput6S = 0;
bool _bounseInput6O = 0;
unsigned long _bounseInput6P = 0UL;
bool _bounseInput9S = 0;
bool _bounseInput9O = 0;
unsigned long _bounseInput9P = 0UL;
bool _bounseInput8S = 0;
bool _bounseInput8O = 0;
unsigned long _bounseInput8P = 0UL;
void setup()
{
_modbusMaster.begin(9600);
_modbusMaster.setTimeOut(1000);
_modState = 0;
_modTelegrSend1.u8id  = 1;
_modTelegrSend1.u8fct  = 16;
_modTelegrSend1.u16RegAdd  = 0;
_modTelegrSend1.u16CoilsNo  = 9;
_modTelegrSend1.au16reg  = _regModSlav_1;
_modTelegrRead1.u8id  = 1;
_modTelegrRead1.u8fct  = 3;
_modTelegrRead1.u16RegAdd  = 0;
_modTelegrRead1.u16CoilsNo  = 9;
_modTelegrRead1.au16reg  = _regModSlav_1;
pinMode(8, INPUT);
digitalWrite(8, HIGH);
pinMode(9, INPUT);
digitalWrite(9, HIGH);
pinMode(6, INPUT);
digitalWrite(6, HIGH);
pinMode(7, INPUT);
digitalWrite(7, HIGH);

_lcd1.begin(16, 2);
_bounseInput7O =  digitalRead(7);
_bounseInput9O =  digitalRead(9);
_bounseInput6O =  digitalRead(6);
_bounseInput8O =  digitalRead(8);
}
void loop()
{if((_isTimer(_modbusTimeVar1, 1000 ))&&(!_isNeesdedSinhronizeSlave1)) { _isNeesdedSinhronizeSlave1= 1; _modbusTimeVar1 = millis();}
switch(_modState) {
case 0:{ 
if((_modTlgIndex == -1)&&(_isNeesdedSinhronizeSlave1)){_modTlgIndex = 1; _isModbusRead = 1; _modState = 1;  break;}
if((_modTlgIndex == 1)&&(_isModbusRead)){
_regModSlav_1[8] = _gtv1;
_regModSlav_1[3] = _bitW1;
_regModSlav_1[4] = _bitW2;
_isModbusRead = 0; _modState = 1; break;}
if((_modTlgIndex == 1)&&( !_isModbusRead)){_modTlgIndex = -1; _isNeesdedSinhronizeSlave1 = 0;}
 break;} 
 case 1:{ 
if((_modTlgIndex == 1)&&(_isModbusRead)) { _modbusMaster.query(_modTelegrRead1); 
_modState = 2;  break; }
if((_modTlgIndex == 1)&&(! _isModbusRead)) { _modbusMaster.query(_modTelegrSend1); 
_modState = 2;  break; }
 break;} 
case 2: 
_modbusMaster.poll();
if (_modbusMaster.getState() == COM_IDLE) {_modState= 0;}
break;
}
if (_isNeedClearDisp1) {_lcd1.clear(); _isNeedClearDisp1= 0;}

bool  _bounceTmp7 =  (digitalRead (7));

if (_bounseInput7S) 
    {
     if (millis() >= (_bounseInput7P + 40)) 
         {_bounseInput7O= _bounceTmp7; _bounseInput7S=0;}
     }
else
    {
     if (_bounceTmp7 != _bounseInput7O )
         {_bounseInput7S=1; _bounseInput7P = millis();} 
      } 
bool  _bounceTmp6 =  (digitalRead (6));

if (_bounseInput6S) 
    {
     if (millis() >= (_bounseInput6P + 40)) 
         {_bounseInput6O= _bounceTmp6; _bounseInput6S=0;}
     }
else
    {
     if (_bounceTmp6 != _bounseInput6O )
         {_bounseInput6S=1; _bounseInput6P = millis();} 
      } 
bool  _bounceTmp9 =  (digitalRead (9));

if (_bounseInput9S) 
    {
     if (millis() >= (_bounseInput9P + 40)) 
         {_bounseInput9O= _bounceTmp9; _bounseInput9S=0;}
     }
else
    {
     if (_bounceTmp9 != _bounseInput9O )
         {_bounseInput9S=1; _bounseInput9P = millis();} 
      } 
bool  _bounceTmp8 =  (digitalRead (8));

if (_bounseInput8S) 
    {
     if (millis() >= (_bounseInput8P + 40)) 
         {_bounseInput8O= _bounceTmp8; _bounseInput8S=0;}
     }
else
    {
     if (_bounceTmp8 != _bounseInput8O )
         {_bounseInput8S=1; _bounseInput8P = millis();} 
      } 



if (1) {
_dispTempLength1 = ((((String("Temp - ")) + ((String((int(_regModSlav_1[0]))))) + (String("  V ")) + ((String((int(_regModSlav_1[1]))))) + (String(" %"))))).length();
if (_disp1oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp1oldLength = _dispTempLength1;
_lcd1.setCursor(0, 0);
_lcd1.print((((String("Temp - ")) + ((String((int(_regModSlav_1[0]))))) + (String("  V ")) + ((String((int(_regModSlav_1[1]))))) + (String(" %")))));
} else {
if (_disp1oldLength > 0) {_isNeedClearDisp1 = 1; _disp1oldLength = 0;} 
}
if (1) {
_dispTempLength1 = ((((String("UST-")) + ((String(_gtv1)))))).length();
if (_disp2oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp2oldLength = _dispTempLength1;
_lcd1.setCursor(0, 1);
_lcd1.print((((String("UST-")) + ((String(_gtv1))))));
} else {
if (_disp2oldLength > 0) {_isNeedClearDisp1 = 1; _disp2oldLength = 0;} 
}
if (( (!(_bounseInput8O)) || (!(_bounseInput9O)) )) { if (! _gen1I) { _gen1I = 1; _gen1O = 1; _gen1P = millis(); } } else { _gen1I = 0 ; _gen1O= 0;}
 if (_gen1I) {  if ( _isTimer ( _gen1P , 200 )) { _gen1P = millis(); _gen1O = ! _gen1O;}}

if (_gen1O) 
   { 
   if (! _count1I)  
      {
        if (!(_bounseInput8O)) {_count1P = _count1P+1;} else {_count1P = _count1P-1;};
       _count1I = 1;
      }
   }
else
   {
   _count1I=0;
   }
_gtv1 = _count1P;
_bitW1 = 1;
  bitWrite(_bitW1, (0), (_trgt1));
_bitW2 = 1;
  bitWrite(_bitW2, (0), (_trgt2));
bool  _tmp1 = !(_bounseInput6O);
if (_tmp1)  { if (! _trgt1I) _trgt1 = ! _trgt1; } 
_trgt1I = _tmp1; 
bool  _tmp2 = !(_bounseInput7O);
if (_tmp2)  { if (! _trgt2I) _trgt2 = ! _trgt2; } 
_trgt2I = _tmp2; 




}
bool _isTimer(unsigned long startTime, unsigned long period )
  {
  unsigned long currentTime;
currentTime = millis();
if (currentTime>= startTime) {return (currentTime>=(startTime + period));} else {return (currentTime >=(4294967295-startTime+period));}
  }
